"{ Package: 'stx:libjava' }"

JavaRef2 subclass:#JavaClassContentRef2
	instanceVariableNames:'classRefIndex nameAndTypeIndex classCache nameAndTypeCache'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Reader-Support-new'
!


!JavaClassContentRef2 class methodsFor:'instance creation'!

in: aJavaConstantPool withNameAndTypeAt: nameAndTypeCPIndex andClassAt: classRefCPIndex 
    ^ self basicNew 
        initializeIn: aJavaConstantPool
        withNameAndTypeAt: nameAndTypeCPIndex
        andClassAt: classRefCPIndex.

    "Created: / 12-05-2011 / 18:36:18 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaClassContentRef2 methodsFor:'accessing'!

classRef
    ^ constantPool at: classRefIndex.

    "Modified: / 12-05-2011 / 18:38:58 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

descriptor
    ^ self nameAndType descriptor.

    "Created: / 08-04-2011 / 15:08:16 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 12-05-2011 / 18:39:16 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

name
    ^ self nameAndType name.

    "Created: / 08-04-2011 / 13:54:28 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 12-05-2011 / 18:39:44 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

nameAndType
    ^ constantPool at: nameAndTypeIndex.

    "Created: / 11-04-2011 / 19:57:16 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 12-05-2011 / 18:39:27 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

selector
    ^ self nameAndType selector.

    "Created: / 11-04-2011 / 20:38:54 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 12-05-2011 / 18:39:33 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

signature
    ^ self nameAndType signature.

    "Created: / 20-05-2011 / 17:10:59 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaClassContentRef2 methodsFor:'comparing'!

= anotherJavaRef
    "superclass JavaRef2 says that I am responsible to implement this method"

    ^ self shouldImplement
!

hash
    "superclass JavaRef2 says that I am responsible to implement this method"

    ^ self shouldImplement
! !

!JavaClassContentRef2 methodsFor:'initialization'!

initializeIn: aJavaConstantPool withNameAndTypeAt: nameAndTypeCPIndex andClassAt: classRefCPIndex    
    constantPool := aJavaConstantPool.
    classRefIndex := classRefCPIndex.
    nameAndTypeIndex := nameAndTypeCPIndex.
    super initialize.

    "Created: / 12-05-2011 / 18:37:10 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaClassContentRef2 methodsFor:'printing'!

printString
    ^ 'JavaClassContentRef: class=[' , self classRef printString , '] name=[' 
        , self nameAndType printString , ']'.

    "Created: / 10-05-2011 / 14:15:39 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 12-05-2011 / 18:40:02 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaClassContentRef2 methodsFor:'resolving'!

invalidate
    self classRef invalidate.    
    classCache := nil.
    nameAndTypeCache := nil.
    super invalidate.

    "Created: / 13-04-2011 / 12:21:38 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 18-05-2011 / 12:41:35 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

invalidateForClass: internalJavaClassName 
    "Invalidate (means call invalidate) reference if it has something to do with given class (e.g Class named internalJavaClassName was unloaded).
     Return true, if reference was invalidated."
    
    (self classRef invalidateForClass: internalJavaClassName) 
        ifTrue: 
            [ self invalidate.
            ^ true ].
    ^ false.

    "Modified: / 12-05-2011 / 18:40:34 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaClassContentRef2 class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
